=== modified file 'drizzled/session.cc'
--- drizzled/session.cc	2010-10-20 20:26:18 +0000
+++ drizzled/session.cc	2010-10-21 05:03:11 +0000
@@ -158,7 +158,7 @@
   Open_tables_state(refresh_version),
   mem_root(&main_mem_root),
   lex(&main_lex),
-  query(),
+  catalog("LOCAL"),
   client(client_arg),
   scheduler(NULL),
   scheduler_arg(NULL),

=== modified file 'drizzled/session.h'
--- drizzled/session.h	2010-10-20 20:26:18 +0000
+++ drizzled/session.h	2010-10-21 05:03:11 +0000
@@ -393,6 +393,7 @@
     only responsible for freeing this member.
   */
   std::string db;
+  std::string catalog;
   /* current cache key */
   std::string query_cache_key;
   /**

=== removed directory 'plugin/database_function'
=== removed file 'plugin/database_function/plugin.ini'
--- plugin/database_function/plugin.ini	2010-02-15 01:56:32 +0000
+++ plugin/database_function/plugin.ini	1970-01-01 00:00:00 +0000
@@ -1,4 +0,0 @@
-[plugin]
-title=DATABASE function
-description=function that returns the current database
-load_by_default=yes

=== removed directory 'plugin/user_function'
=== removed file 'plugin/user_function/plugin.ini'
--- plugin/user_function/plugin.ini	2010-03-18 11:20:28 +0000
+++ plugin/user_function/plugin.ini	1970-01-01 00:00:00 +0000
@@ -1,4 +0,0 @@
-[plugin]
-title=USER() Function
-description=Gets current user
-load_by_default=yes

=== added directory 'plugin/utility_functions'
=== added file 'plugin/utility_functions/catalog.cc'
--- plugin/utility_functions/catalog.cc	1970-01-01 00:00:00 +0000
+++ plugin/utility_functions/catalog.cc	2010-10-21 08:55:44 +0000
@@ -0,0 +1,51 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 Sun Microsystems
+ *  Copyright (C) 2010 Stewart Smith
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#include "config.h"
+
+#include <drizzled/session.h>
+#include <drizzled/function/str/strfunc.h>
+#include "plugin/utility_functions/functions.h"
+
+namespace drizzled
+{
+
+namespace utility_functions
+{
+
+String *Catalog::val_str(String *str)
+{
+  assert(fixed == 1);
+  Session *session= current_session;
+  if (session->catalog.empty())
+  {
+    null_value= 1;
+    return 0;
+  }
+  else
+  {
+    str->copy(session->catalog.c_str(), session->catalog.length(), system_charset_info);
+  }
+
+  return str;
+}
+
+} /* namespace utility_functions */
+} /* namespace drizzled */

=== added file 'plugin/utility_functions/catalog.h'
--- plugin/utility_functions/catalog.h	1970-01-01 00:00:00 +0000
+++ plugin/utility_functions/catalog.h	2010-10-21 08:55:44 +0000
@@ -0,0 +1,49 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2010 Brian Aker
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+
+#ifndef PLUGIN_UTILITY_FUNCTIONS_CATALOG_H
+#define PLUGIN_UTILITY_FUNCTIONS_CATALOG_H
+
+#include <drizzled/function/str/strfunc.h>
+
+namespace drizzled
+{
+
+namespace utility_functions
+{
+
+class Catalog :public Item_str_func
+{
+public:
+  Catalog() :Item_str_func() {}
+  String *val_str(String *);
+  void fix_length_and_dec()
+  {
+    max_length= MAX_FIELD_NAME * system_charset_info->mbmaxlen;
+    maybe_null=1;
+  }
+  const char *func_name() const { return "catalog"; }
+  const char *fully_qualified_func_name() const { return "catalog()"; }
+};
+
+} /* namespace utility_functions */
+} /* namespace drizzled */
+
+#endif /* PLUGIN_UTILITY_FUNCTIONS_CATALOG_H */

=== added file 'plugin/utility_functions/functions.cc'
--- plugin/utility_functions/functions.cc	1970-01-01 00:00:00 +0000
+++ plugin/utility_functions/functions.cc	2010-10-21 08:55:44 +0000
@@ -0,0 +1,48 @@
+/* - mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2010 Brian Aker
+ *  Copyright (C) 2010 Stewart Smith
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#include "config.h"
+#include "plugin/utility_functions/functions.h"
+
+using namespace drizzled;
+
+static int init(drizzled::module::Context &context)
+{
+  context.add(new plugin::Create_function<utility_functions::Catalog>("catalog"));
+  context.add(new plugin::Create_function<utility_functions::Schema>("database"));
+  context.add(new plugin::Create_function<utility_functions::User>("user"));
+
+  return 0;
+}
+
+DRIZZLE_DECLARE_PLUGIN
+{
+  DRIZZLE_VERSION_ID,
+  "Utility Functions",
+  "1.0",
+  "Brian Aker, Stewart Smith",
+  "Utility Functions.",
+  PLUGIN_LICENSE_GPL,
+  init,
+  NULL,
+  NULL
+}
+DRIZZLE_DECLARE_PLUGIN_END;

=== added file 'plugin/utility_functions/functions.h'
--- plugin/utility_functions/functions.h	1970-01-01 00:00:00 +0000
+++ plugin/utility_functions/functions.h	2010-10-21 08:55:44 +0000
@@ -0,0 +1,31 @@
+/* - mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2010 Brian Aker
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifndef PLUGIN_UTILITY_FUNCTIONS_FUNCTIONS_H
+#define PLUGIN_UTILITY_FUNCTIONS_FUNCTIONS_H
+
+#include <drizzled/function/func.h>
+#include <drizzled/plugin/function.h>
+
+#include "plugin/utility_functions/catalog.h"
+#include "plugin/utility_functions/schema.h"
+#include "plugin/utility_functions/user.h"
+
+#endif /* PLUGIN_UTILITY_FUNCTIONS_FUNCTIONS_H */

=== added file 'plugin/utility_functions/plugin.ini'
--- plugin/utility_functions/plugin.ini	1970-01-01 00:00:00 +0000
+++ plugin/utility_functions/plugin.ini	2010-10-21 07:52:43 +0000
@@ -0,0 +1,15 @@
+[plugin]
+title=Utility Functions
+description= Utility Functions
+load_by_default=yes
+sources= 
+  catalog.cc
+  functions.cc
+  schema.cc
+  user.cc
+headers=
+  catalog.h
+  functions.h
+  schema.h
+  user.cc
+static=yes

=== renamed file 'plugin/database_function/database_function.cc' => 'plugin/utility_functions/schema.cc'
--- plugin/database_function/database_function.cc	2010-05-18 18:20:56 +0000
+++ plugin/utility_functions/schema.cc	2010-10-21 08:55:44 +0000
@@ -21,25 +21,15 @@
 #include "config.h"
 
 #include <drizzled/session.h>
-#include <drizzled/function/str/strfunc.h>
-
-using namespace drizzled;
-
-class DatabaseFunction :public Item_str_func
-{
-public:
-  DatabaseFunction() :Item_str_func() {}
-  String *val_str(String *);
-  void fix_length_and_dec()
-  {
-    max_length= MAX_FIELD_NAME * system_charset_info->mbmaxlen;
-    maybe_null=1;
-  }
-  const char *func_name() const { return "database"; }
-  const char *fully_qualified_func_name() const { return "database()"; }
-};
-
-String *DatabaseFunction::val_str(String *str)
+#include "plugin/utility_functions/functions.h"
+
+namespace drizzled
+{
+
+namespace utility_functions
+{
+
+String *Schema::val_str(String *str)
 {
   assert(fixed == 1);
   Session *session= current_session;
@@ -49,29 +39,11 @@
     return 0;
   }
   else
+  {
     str->copy(session->db.c_str(), session->db.length(), system_charset_info);
+  }
   return str;
 }
 
-plugin::Create_function<DatabaseFunction> *database_function= NULL;
-
-static int initialize(drizzled::module::Context &context)
-{
-  database_function= new plugin::Create_function<DatabaseFunction>("database");
-  context.add(database_function);
-  return 0;
-}
-
-DRIZZLE_DECLARE_PLUGIN
-{
-  DRIZZLE_VERSION_ID,
-  "database_function",
-  "1.0",
-  "Stewart Smith",
-  "returns the current database",
-  PLUGIN_LICENSE_GPL,
-  initialize, /* Plugin Init */
-  NULL,   /* system variables */
-  NULL    /* config options */
-}
-DRIZZLE_DECLARE_PLUGIN_END;
+} /* namespace utility_functions */
+} /* namespace drizzled */

=== added file 'plugin/utility_functions/schema.h'
--- plugin/utility_functions/schema.h	1970-01-01 00:00:00 +0000
+++ plugin/utility_functions/schema.h	2010-10-21 08:55:44 +0000
@@ -0,0 +1,50 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2010 Brian Aker
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+
+#ifndef PLUGIN_UTILITY_FUNCTIONS_SCHEMA_H
+#define PLUGIN_UTILITY_FUNCTIONS_SCHEMA_H
+
+#include <drizzled/function/str/strfunc.h>
+
+namespace drizzled
+{
+
+namespace utility_functions
+{
+
+class Schema :public Item_str_func
+{
+public:
+  Schema() :Item_str_func() {}
+  String *val_str(String *);
+  void fix_length_and_dec()
+  {
+    max_length= MAX_FIELD_NAME * system_charset_info->mbmaxlen;
+    maybe_null=1;
+  }
+  const char *func_name() const { return "schema"; }
+  const char *fully_qualified_func_name() const { return "schema()"; }
+};
+
+
+} /* namespace utility_functions */
+} /* namespace drizzled */
+
+#endif /* PLUGIN_UTILITY_FUNCTIONS_SCHEMA_H */

=== added directory 'plugin/utility_functions/tests'
=== added directory 'plugin/utility_functions/tests/r'
=== added file 'plugin/utility_functions/tests/r/catalog.result'
--- plugin/utility_functions/tests/r/catalog.result	1970-01-01 00:00:00 +0000
+++ plugin/utility_functions/tests/r/catalog.result	2010-10-21 05:03:11 +0000
@@ -0,0 +1,3 @@
+SELECT CATALOG();
+CATALOG()
+LOCAL

=== added file 'plugin/utility_functions/tests/r/schema.result'
--- plugin/utility_functions/tests/r/schema.result	1970-01-01 00:00:00 +0000
+++ plugin/utility_functions/tests/r/schema.result	2010-10-21 06:52:47 +0000
@@ -0,0 +1,30 @@
+SELECT SCHEMA();
+SCHEMA()
+test
+SELECT DATABASE();
+DATABASE()
+test
+CREATE SCHEMA foo;
+SELECT SCHEMA();
+SCHEMA()
+test
+SELECT DATABASE();
+DATABASE()
+test
+use foo;
+SELECT SCHEMA();
+SCHEMA()
+foo
+SELECT DATABASE();
+DATABASE()
+foo
+SELECT CATALOG();
+CATALOG()
+LOCAL
+DROP SCHEMA foo;
+SELECT SCHEMA();
+SCHEMA()
+NULL
+SELECT DATABASE();
+DATABASE()
+NULL

=== added file 'plugin/utility_functions/tests/r/user.result'
--- plugin/utility_functions/tests/r/user.result	1970-01-01 00:00:00 +0000
+++ plugin/utility_functions/tests/r/user.result	2010-10-21 07:52:43 +0000
@@ -0,0 +1,6 @@
+SELECT USER();
+USER()
+#
+SELECT CURRENT_USER();
+CURRENT_USER()
+#

=== added directory 'plugin/utility_functions/tests/t'
=== added file 'plugin/utility_functions/tests/t/catalog.test'
--- plugin/utility_functions/tests/t/catalog.test	1970-01-01 00:00:00 +0000
+++ plugin/utility_functions/tests/t/catalog.test	2010-10-21 05:03:11 +0000
@@ -0,0 +1,1 @@
+SELECT CATALOG();

=== added file 'plugin/utility_functions/tests/t/schema.test'
--- plugin/utility_functions/tests/t/schema.test	1970-01-01 00:00:00 +0000
+++ plugin/utility_functions/tests/t/schema.test	2010-10-21 06:52:47 +0000
@@ -0,0 +1,15 @@
+SELECT SCHEMA();
+SELECT DATABASE();
+
+CREATE SCHEMA foo;
+SELECT SCHEMA();
+SELECT DATABASE();
+
+use foo;
+SELECT SCHEMA();
+SELECT DATABASE();
+SELECT CATALOG();
+DROP SCHEMA foo;
+
+SELECT SCHEMA();
+SELECT DATABASE();

=== added file 'plugin/utility_functions/tests/t/user.test'
--- plugin/utility_functions/tests/t/user.test	1970-01-01 00:00:00 +0000
+++ plugin/utility_functions/tests/t/user.test	2010-10-21 07:52:43 +0000
@@ -0,0 +1,5 @@
+--replace_column 1 #
+SELECT USER();
+
+--replace_column 1 #
+SELECT CURRENT_USER();

=== renamed file 'plugin/user_function/user_function.cc' => 'plugin/utility_functions/user.cc'
--- plugin/user_function/user_function.cc	2010-05-18 18:20:56 +0000
+++ plugin/utility_functions/user.cc	2010-10-21 20:21:18 +0000
@@ -20,100 +20,31 @@
 
 #include "config.h"
 
-#include <drizzled/plugin/function.h>
 #include <drizzled/session.h>
-
-using namespace std;
-using namespace drizzled;
-
-#include <drizzled/function/str/strfunc.h>
-
-class UserFunction :public Item_str_func
-{
-protected:
-  bool init (const char *user, const char *host);
-
-public:
-  UserFunction()
-  {
-    str_value.set("", 0, system_charset_info);
-  }
-  String *val_str(String *)
-  {
-    assert(fixed == 1);
-    return (null_value ? 0 : &str_value);
-  }
-  bool fix_fields(Session *session, Item **ref);
-  void fix_length_and_dec()
-  {
-    max_length= (USERNAME_CHAR_LENGTH + HOSTNAME_LENGTH + 1) *
-                system_charset_info->mbmaxlen;
-  }
-  const char *func_name() const { return "user"; }
-  const char *fully_qualified_func_name() const { return "user()"; }
-  int save_in_field(Field *field,
-                    bool )
-  {
-    return save_str_value_in_field(field, &str_value);
-  }
-};
-
-/**
-  @todo
-  make USER() replicate properly (currently it is replicated to "")
-*/
-bool UserFunction::init(const char *user, const char *host)
+#include "plugin/utility_functions/functions.h"
+
+namespace drizzled
+{
+
+namespace utility_functions
+{
+
+
+String *User::val_str(String *str)
 {
   assert(fixed == 1);
-
-  // For system threads (e.g. replication SQL thread) user may be empty
-  if (user)
-  {
-    const CHARSET_INFO * const cs= str_value.charset();
-    uint32_t res_length= (strlen(user)+strlen(host)+2) * cs->mbmaxlen;
-
-    if (str_value.alloc(res_length))
-    {
-      null_value=1;
-      return true;
-    }
-
-    res_length=cs->cset->snprintf(cs, (char*)str_value.ptr(), res_length,
-                                  "%s@%s", user, host);
-    str_value.length(res_length);
-    str_value.mark_as_const();
-  }
-  return false;
-}
-
-
-bool UserFunction::fix_fields(Session *session, Item **ref)
-{
-  return (Item_str_func::fix_fields(session, ref) ||
-          init(session->getSecurityContext().getUser().c_str(),
-               session->getSecurityContext().getIp().c_str()));
-}
-
-
-plugin::Create_function<UserFunction> *user_function= NULL;
-
-static int initialize(drizzled::module::Context &context)
-{
-  user_function= new plugin::Create_function<UserFunction>("user");
-  context.add(user_function);
-  return 0;
-}
-
-DRIZZLE_DECLARE_PLUGIN
-{
-  DRIZZLE_VERSION_ID,
-  "user_function",
-  "1.0",
-  "Stewart Smith",
-  "USER() and CURRENT_USER()",
-  PLUGIN_LICENSE_GPL,
-  initialize, /* Plugin Init */
-  NULL,   /* system variables */
-  NULL    /* config options */
-}
-DRIZZLE_DECLARE_PLUGIN_END;
+  Session *session= current_session;
+  if (session->getSecurityContext().getUser().empty())
+  {
+    null_value= 1;
+    return 0;
+  }
+  else
+  {
+    str->copy(session->getSecurityContext().getUser().c_str(), session->getSecurityContext().getUser().length(), system_charset_info);
+  }
+  return str;
+}
+
+} /* namespace utility_functions */
+} /* namespace drizzled */

=== added file 'plugin/utility_functions/user.h'
--- plugin/utility_functions/user.h	1970-01-01 00:00:00 +0000
+++ plugin/utility_functions/user.h	2010-10-21 20:21:18 +0000
@@ -0,0 +1,51 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2010 Brian Aker
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+
+#ifndef PLUGIN_UTILITY_FUNCTIONS_USER_H
+#define PLUGIN_UTILITY_FUNCTIONS_USER_H
+
+#include <drizzled/function/str/strfunc.h>
+
+namespace drizzled
+{
+
+namespace utility_functions
+{
+
+class User :public Item_str_func
+{
+public:
+  User()
+  { }
+
+  String *val_str(String *);
+  void fix_length_and_dec()
+  {
+    max_length= (USERNAME_CHAR_LENGTH + HOSTNAME_LENGTH + 1) *
+                system_charset_info->mbmaxlen;
+  }
+  const char *func_name() const { return "user"; }
+  const char *fully_qualified_func_name() const { return "user()"; }
+};
+
+} /* namespace utility_functions */
+} /* namespace drizzled */
+
+#endif /* PLUGIN_UTILITY_FUNCTIONS_USER_H */

=== modified file 'tests/r/func_system.result'
--- tests/r/func_system.result	2010-09-02 18:35:05 +0000
+++ tests/r/func_system.result	2010-10-21 20:21:18 +0000
@@ -6,7 +6,7 @@
 1
 select user() like "%@%";
 user() like "%@%"
-1
+#
 select version() > "2009.01.756";
 version() > "2009.01.756"
 1
@@ -14,7 +14,7 @@
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	filtered	Extra
 1	SIMPLE	NULL	NULL	NULL	NULL	NULL	NULL	NULL	NULL	No tables used
 Warnings:
-Note	1003	select database() AS `database()`,user() AS `user()`
+Note	1003	select schema() AS `database()`,user() AS `user()`
 create table t1 (version char(60)) select database(), user(), version() as 'version';
 show create table t1;
 Table	Create Table

=== modified file 'tests/t/func_system.test'
--- tests/t/func_system.test	2009-03-25 09:18:25 +0000
+++ tests/t/func_system.test	2010-10-21 20:21:18 +0000
@@ -5,6 +5,7 @@
 select database();
 select database() = "test";
 
+--replace_column 1 #
 select user() like "%@%";
 
 select version() > "2009.01.756";

